# Alex' "Oh My ZSH" Extensions


## Prerequisites

1. You must be using ZSH and
2. ["OhMyZsh"](https://github.com/robbyrussell/oh-my-zsh) must be installed
   and set up properly.


## Installation

1. Download and copy the "OhMyZshExtensions" directory anywhere to the local
   system, or even better, clone the project using Git.
2. Set up the `ZSH_CUSTOM` variable in your `$HOME/.zshrc` file to correctly
   point to the "OhMyZshExtensions" directory.
3. Add the desired plugins the the `plugins` array in your `$HOME/.zshrc` file.


## Plugins

### 0_console (*recommended*)

Use `tset` to make sure that `$TERM` is set to a valid value.

### 1_local (*required*)

Try to create a "local" home directory (which is local to the current
system and not stored on NFS, for example), set `$LOCAL_HOME` accordingly,
set `XDG_CACHE_HOME`, and add user-local path names to `$PATH`.

### 5_dev_env

Use a SSH wrapper script for Git (when available) and setup Python Pip
environment (`$PIP_REQUIRE_VIRTUALENV`, `$PIP_DOWNLOAD_CACHE`, `$WORKON_HOME`,
and `$PROJECT_HOME`).

### accounting

Setup to aliases for `last`: `lasth` (show only one page of `head` output) and
`lastf` (show only "foreign" logins).

### boot2docker

Initialize environment for `boot2docker`, including `$DOCKER_HOST_IPA`. Requires
a running boot2docker VM.

### ccache

Setup `ccache` environment (`$CCACHE_DIR`), search for `ccache` wrapper scripts,
and adjust `$PATH` accordingly.

### editor_select

Automatically setup `$EDITOR` with the *best* editor found on the system. Search
order is: atom, mate, subl, vim, vi.

### keychain

Setup SSH and GnuPG agents using `keychain`.

### reminders

Show reminds in the console using `iCalBuddy` (OS X) or `remind`. Reminders
aren't shown more often than once every hour.

### ssh

Define three aliases for SSH:

- Enfoce "StrictHostKeyChecking yes" for `ssh`,
- Disable "StrictHostKeyChecking" for `sshnew` to add new hosts,
- and define `sshtmp` to temporarily disable "StrictHostKeyChecking"
  and to bypass the `known_hosts` file.

### thefuck

Alias `fuck` to correct the last entered command using `thefuck`.

### z9_local_conf

Read in system-local configuration form `/var/lib/$HOSTNAME/zshrc`, when
available.
